pipeline{
    agent any
    stages{
        stage('Build'){
             steps{
                 bat 'mvn clean package -DskipTests=true'
             }
        }
        stage('Unit Tests'){
            steps{
                bat 'mvn test'
            }
        }
        stage('Sonar Analysis'){
            environment{
                scannerHome=tool 'SONAR_SCANNER'
            }
            steps{
                withSonarQubeEnv('SONAR_LOCAL'){
                    bat "${scannerHome}/bin/sonar-scanner -e -Dsonar.projectKey=DeployBack -Dsonar.host.url=http://localhost:9000 -Dsonar.login=sqp_3db14d3b8298f8f5930c1e506c3e7889229a35cd -Dsonar.java.binaries=target -Dsonar.coverage.exclusions=**/.mvn/**,**/src/test/**,**/model/**,**Application.java"
                }
            }
        }
        stage('Quality Gate'){
            steps{
                sleep(5)
                timeout(time: 1, unit: 'MINUTES'){
                    waitForQualityGate abortPipeline: true
                }
            }
        }
        stage('Deploy Backend'){
            steps{
                deploy adapters: [tomcat9(credentialsId: 'tomcat_login', path: '', url: 'http://localhost:8001')], contextPath: 'tasks-backend', war: 'target/tasks-backend.war'
            }
        }
        stage('Api Test'){
            steps{
                dir('api-test') {
                    git branch: 'main', credentialsId: 'github_login', url: 'https://gitlab.com/java4812145/java-concept-project/tasks-api-test'
                    bat 'mvn test'
                }
            }
        }
        stage('Deploy Frontend'){
            steps{
                dir('frontend') {
                    git branch: 'master', credentialsId: 'github_login', url: 'https://gitlab.com/java4812145/java-concept-project/tasks-frontend'
                    bat 'mvn clean package'
                    deploy adapters: [tomcat9(credentialsId: 'tomcat_login', path: '', url: 'http://localhost:8001')], contextPath: 'tasks', war: 'target/tasks.war'
                }
            }
        }
        stage('Functional Test'){
                    steps{
                        dir('functional-test') {
                            git branch: 'main', credentialsId: 'github_login', url: 'https://gitlab.com/java4812145/java-concept-project/tasks-functional-test'
                            bat 'mvn test'
                        }
                    }
                }
    }
}